Index: stable/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 14186)
+++ stable/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 14530)
@@ -46,5 +46,4 @@
     /// </summary>
     private void InitializeComponent() {
-      this.btnImpactCalculation = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -54,26 +53,4 @@
       this.detailsGroupBox.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // btnImpactCalculation
-      // 
-      this.btnImpactCalculation.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
-      this.btnImpactCalculation.Image = HeuristicLab.Common.Resources.VSImageLibrary.Zoom;
-      this.btnImpactCalculation.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
-      this.btnImpactCalculation.Name = "btnImpactCalculation";
-      this.btnImpactCalculation.TabIndex = 6;
-      this.btnImpactCalculation.Size = new System.Drawing.Size(110, 24);
-      this.btnImpactCalculation.Text = "Variable Impacts";
-      this.btnImpactCalculation.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
-      this.btnImpactCalculation.UseVisualStyleBackColor = true;
-      this.btnImpactCalculation.Click += new System.EventHandler(this.btnImpactCalculation_Click);
-      this.toolTip.SetToolTip(this.btnImpactCalculation, "Calculate impacts");
-      // 
-      // flowLayoutPanel
-      // 
-      this.flowLayoutPanel.Controls.Add(this.btnImpactCalculation);
-      // 
-      // splitContainer
-      // 
-      // 
       // itemsGroupBox
       // 
@@ -104,6 +81,4 @@
 
     #endregion
-
-    protected System.Windows.Forms.Button btnImpactCalculation;
   }
 }
Index: stable/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 14186)
+++ stable/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 14530)
@@ -20,13 +20,7 @@
 #endregion
 
-using System;
-using System.Linq;
-using System.Threading.Tasks;
 using System.Windows.Forms;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Data.Views;
 using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
@@ -41,30 +35,4 @@
       get { return (RegressionSolutionBase)base.Content; }
       set { base.Content = value; }
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      btnImpactCalculation.Enabled = Content != null && !Locked;
-    }
-
-    protected virtual void btnImpactCalculation_Click(object sender, EventArgs e) {
-      var mainForm = (MainForm.WindowsForms.MainForm)MainFormManager.MainForm;
-      var view = new StringConvertibleArrayView();
-      view.Caption = Content.Name + " Variable Impacts";
-      view.Show();
-
-      Task.Factory.StartNew(() => {
-        try {
-          mainForm.AddOperationProgressToView(view, "Calculating variable impacts for " + Content.Name);
-
-          var impacts = RegressionSolutionVariableImpactsCalculator.CalculateImpacts(Content);
-          var impactArray = new DoubleArray(impacts.Select(i => i.Item2).ToArray());
-          impactArray.ElementNames = impacts.Select(i => i.Item1);
-          view.Content = (DoubleArray)impactArray.AsReadOnly();
-        }
-        finally {
-          mainForm.RemoveOperationProgressFromView(view);
-        }
-      });
     }
 